com.fasterxml.jackson.annotation

## Class JsonAutoDetect.Value

- java.lang.Object
- - com.fasterxml.jackson.annotation.JsonAutoDetect.Value

All Implemented Interfaces:
  JacksonAnnotationValue<JsonAutoDetect>, Serializable

Enclosing class:
  JsonAutoDetect

    public static class JsonAutoDetect.Value
    extends Object
    implements JacksonAnnotationValue<JsonAutoDetect>, Serializable

Helper class used to contain information from a single `JsonIgnoreProperties` annotation, as well as to provide possible overrides from non-annotation sources.

Since:
  2.9
See Also:
  Serialized Form

### Field Summary

Fields
`protected JsonAutoDetect.Visibility` `_creatorVisibility`
`protected JsonAutoDetect.Visibility` `_fieldVisibility`
`protected JsonAutoDetect.Visibility` `_getterVisibility`
`protected JsonAutoDetect.Visibility` `_isGetterVisibility`
`protected JsonAutoDetect.Visibility` `_setterVisibility`
`protected static JsonAutoDetect.Value` `DEFAULT` Default instance with baseline visibility checking: Only public fields visible Only public getters, is-getters visible All setters (regardless of access) visible Only public Creators visible
`protected static JsonAutoDetect.Value` `NO_OVERRIDES` Empty instance that specifies no overrides, that is, all visibility levels set as `JsonAutoDetect.Visibility.DEFAULT`.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`static JsonAutoDetect.Value` `construct(JsonAutoDetect.Visibility fields, JsonAutoDetect.Visibility getters, JsonAutoDetect.Visibility isGetters, JsonAutoDetect.Visibility setters, JsonAutoDetect.Visibility creators)`
`static JsonAutoDetect.Value` `construct(PropertyAccessor acc, JsonAutoDetect.Visibility visibility)` Factory method for cnstructing instance with visibility of specified accessor (or, in case of `ALL`, all of them) set as specified; and the rest (if any) set as `JsonAutoDetect.Visibility.DEFAULT`).
`static JsonAutoDetect.Value` `defaultVisibility()`
`boolean` `equals(Object o)`
`static JsonAutoDetect.Value` `from(JsonAutoDetect src)`
`JsonAutoDetect.Visibility` `getCreatorVisibility()`
`JsonAutoDetect.Visibility` `getFieldVisibility()`
`JsonAutoDetect.Visibility` `getGetterVisibility()`
`JsonAutoDetect.Visibility` `getIsGetterVisibility()`
`JsonAutoDetect.Visibility` `getSetterVisibility()`
`int` `hashCode()`
`static JsonAutoDetect.Value` `merge(JsonAutoDetect.Value base, JsonAutoDetect.Value overrides)`
`static JsonAutoDetect.Value` `noOverrides()`
`protected Object` `readResolve()`
`String` `toString()`
`Class<JsonAutoDetect>` `valueFor()` Introspection method that may be used to find actual annotation that may be used as the source for value instance.
`JsonAutoDetect.Value` `withCreatorVisibility(JsonAutoDetect.Visibility v)`
`JsonAutoDetect.Value` `withFieldVisibility(JsonAutoDetect.Visibility v)`
`JsonAutoDetect.Value` `withGetterVisibility(JsonAutoDetect.Visibility v)`
`JsonAutoDetect.Value` `withIsGetterVisibility(JsonAutoDetect.Visibility v)`
`JsonAutoDetect.Value` `withOverrides(JsonAutoDetect.Value overrides)`
`JsonAutoDetect.Value` `withSetterVisibility(JsonAutoDetect.Visibility v)`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### DEFAULT

    protected static final JsonAutoDetect.Value DEFAULT

Default instance with baseline visibility checking:

- Only public fields visible
- Only public getters, is-getters visible
- All setters (regardless of access) visible
- Only public Creators visible

#### NO_OVERRIDES

    protected static final JsonAutoDetect.Value NO_OVERRIDES

Empty instance that specifies no overrides, that is, all visibility levels set as `JsonAutoDetect.Visibility.DEFAULT`.

#### _fieldVisibility

    protected final JsonAutoDetect.Visibility _fieldVisibility

#### _getterVisibility

    protected final JsonAutoDetect.Visibility _getterVisibility

#### _isGetterVisibility

    protected final JsonAutoDetect.Visibility _isGetterVisibility

#### _setterVisibility

    protected final JsonAutoDetect.Visibility _setterVisibility

#### _creatorVisibility

    protected final JsonAutoDetect.Visibility _creatorVisibility

### Method Detail

#### defaultVisibility

    public static JsonAutoDetect.Value defaultVisibility()

#### noOverrides

    public static JsonAutoDetect.Value noOverrides()

#### from

    public static JsonAutoDetect.Value from(JsonAutoDetect src)

#### construct

    public static JsonAutoDetect.Value construct(PropertyAccessor acc,
                                                 JsonAutoDetect.Visibility visibility)

Factory method for cnstructing instance with visibility of specified accessor (or, in case of `ALL`, all of them) set as specified; and the rest (if any) set as `JsonAutoDetect.Visibility.DEFAULT`).

#### construct

    public static JsonAutoDetect.Value construct(JsonAutoDetect.Visibility fields,
                                                 JsonAutoDetect.Visibility getters,
                                                 JsonAutoDetect.Visibility isGetters,
                                                 JsonAutoDetect.Visibility setters,
                                                 JsonAutoDetect.Visibility creators)

#### withFieldVisibility

    public JsonAutoDetect.Value withFieldVisibility(JsonAutoDetect.Visibility v)

#### withGetterVisibility

    public JsonAutoDetect.Value withGetterVisibility(JsonAutoDetect.Visibility v)

#### withIsGetterVisibility

    public JsonAutoDetect.Value withIsGetterVisibility(JsonAutoDetect.Visibility v)

#### withSetterVisibility

    public JsonAutoDetect.Value withSetterVisibility(JsonAutoDetect.Visibility v)

#### withCreatorVisibility

    public JsonAutoDetect.Value withCreatorVisibility(JsonAutoDetect.Visibility v)

#### merge

    public static JsonAutoDetect.Value merge(JsonAutoDetect.Value base,
                                             JsonAutoDetect.Value overrides)

#### withOverrides

    public JsonAutoDetect.Value withOverrides(JsonAutoDetect.Value overrides)

#### valueFor

    public Class<JsonAutoDetect> valueFor()

Description copied from interface: `JacksonAnnotationValue`
Introspection method that may be used to find actual annotation that may be used as the source for value instance.

Specified by:
  `valueFor` in interface `JacksonAnnotationValue<JsonAutoDetect>`
Returns:
  Annotation class for which instances of this value class are created

#### getFieldVisibility

    public JsonAutoDetect.Visibility getFieldVisibility()

#### getGetterVisibility

    public JsonAutoDetect.Visibility getGetterVisibility()

#### getIsGetterVisibility

    public JsonAutoDetect.Visibility getIsGetterVisibility()

#### getSetterVisibility

    public JsonAutoDetect.Visibility getSetterVisibility()

#### getCreatorVisibility

    public JsonAutoDetect.Visibility getCreatorVisibility()

#### readResolve

    protected Object readResolve()

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `Object`

#### equals

    public boolean equals(Object o)

Overrides:
  `equals` in class `Object`